package eu.telecomnancy;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.BeforeEach;


import static org.junit.jupiter.api.Assertions.assertTrue;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertEquals;


public class StudentTest {

    @BeforeEach
    void testStudent() {
        Student claire = new Student("Claire",9);
        Student marianne = new Student("Marianne",20);
    }

    @Test
	public void testGetName() {
		assertEquals("Claire", claire.getName());
		assertEquals("Marianne", marianne.getName());
	}

		@Test
	public void testSetName() {
		assertEquals("Claire", claire.getName());
		claire.setName("Chiara");
		assertEquals("Chiara", claire.getName());

		assertEquals("Marianne", marianne.getName());
		marianne.setName("Marianne");
		assertEquals("Marie-Anne", marianne.getName());
	}

	@Test
	public void testGetId() {
		assertEquals(9, claire.getId());
		assertEquals(20, marianne.getId());

	}

	@Test
	public void testSetId() {
		claire.setId(0);
		assertEquals(0, claire.getId());

		marianne.setId(1);
		assertEquals(1, marianne.getId());
		marianne.setId(2);
		assertEquals(2, marianne.getId());
	}


	@Test
	public void testToStrings() {
		assertEquals("name : Claire, id : 9", claire.toString());
		claire.setId(2);
		assertEquals("name : Claire, id : 2", claire.toString());
		claire.setId(0);
		claire.setName("Chiara");

		assertEquals("name : Chiara, id : 0", claire.toString());
	}


	@Test
	public void testEquals() {
		assertFalse(claire.equals(marianne));
		assertFalse(marianne.equals(claire));

		marianne.setId(9);

		assertFalse(claire.equals(marianne));
		assertFalse(marianne.equals(claire));

		marianne.setName("Claire");

		assertTrue(claire.equals(marianne));
		assertTrue(marianne.equals(claire));

		marianne.setId(2);

		assertFalse(claire.equals(marianne));
		assertFalse(marianne.equals(claire));
	}


}
